// Generated by CoffeeScript 1.8.0
"use strict";
var allBchannels, channels, configurator, exec, fs, helper, iconvlite, isWatching, jsonifyChannelFile, logger, watcher, _;

helper = require("omg-helperfunctions");

configurator = require("omg-configurator");

_ = require("lodash");

exec = require("child_process").exec;

logger = require("omg-logger");

iconvlite = require("iconv-lite");

fs = require("fs");

channels = {};

channels.bchannels = {};

channels.dchannels = [];

allBchannels = channels.bchannels;

isWatching = false;

watcher = false;

jsonifyChannelFile = function(filename) {
  var content, contentAsJson, decodedContent, someArray;
  content = fs.readFileSync(filename);
  decodedContent = iconvlite.decode(content, "utf-8");
  someArray = decodedContent.split("--");
  contentAsJson = {};
  _.each(someArray, function(keyValObject) {
    var newKey, newVal, tempArray;
    tempArray = keyValObject.split("=");
    newKey = tempArray[0];
    newVal = tempArray[1];
    try {
      newKey = JSON.parse(newKey);
    } catch (_error) {}
    try {
      newVal = JSON.parse(newVal);
    } catch (_error) {}
    contentAsJson[newKey] = newVal;
  });
  return contentAsJson;
};

exec("getchannels -m -b 2>&1 | grep -v 'B-Channels found'", function(error, stdout) {
  stdout = stdout.split("\n");
  stdout = _.filter(stdout, function(line) {
    return (line !== "") && (line.indexOf("B-Channels") === -1 && line.indexOf("D-Channels") === -1);
  });
  _.each(stdout, function(bchannelName) {
    allBchannels[bchannelName] = {};
  });
});

exports.start = function(outputCallback) {
  var confOutputCallback, confStartCallback, sendChangedFile, watchDir;
  confStartCallback = function() {};
  confOutputCallback = function() {};
  configurator.get("config.lua struct_Dchannel", confStartCallback, confOutputCallback);
  sendChangedFile = function(filename) {
    var bchannelData, bchannelName, changedChannels, changes;
    bchannelData = jsonifyChannelFile(filename);
    bchannelName = bchannelData.bchannel;
    changes = {};
    changes.bchannels = {};
    changedChannels = changes.bchannels;
    changedChannels[bchannelName] = bchannelData;
    outputCallback(null, changes);
  };
  outputCallback(null, channels);
  if (!isWatching) {
    isWatching = true;
    watchDir = "/tmp/";
    watcher = fs.watch(watchDir, function(event, filename) {
      if (filename.lastIndexOf("BChannelState", 0) === 0) {
        sendChangedFile(watchDir + filename);
      }
    });
  }
};

exports.stop = function() {};


/*!
older stuff
 */

exports.getChannelNames = function(next) {
  var cmd, fxs, mapping, pcm, pris, s0;
  mapping = [];
  pris = 0;
  fxs = 0;
  s0 = 0;
  pcm = 0;
  cmd = "getchannels -m -d 2>&1 | sort -n -t . -k 1 | grep -v 'B-Channels'";
  helper.stdout2array(cmd, function(err, data) {
    _.each(data, function(item) {
      var sp;
      sp = item.split("/");
      if (sp[2] === "S2M") {
        pris++;
        mapping.push({
          chan: sp[0],
          name: "PRI" + pris
        });
      } else if (sp[2] === "FXS") {
        fxs++;
        mapping.push({
          chan: sp[0],
          name: "Analog" + fxs
        });
      } else if (sp[2] === "S0") {
        s0++;
        mapping.push({
          chan: sp[0],
          name: "BRI" + s0
        });
      } else {
        pcm++;
        mapping.push({
          chan: sp[0],
          name: "PCM" + pcm
        });
      }
    });
    next(err, mapping);
  });
};

exports.initialBchannelState = function(next) {
  exec("getchannels -m -b 2>&1 | grep -v 'D-Channels found'", function(error, stdout) {
    var Bchannels, data;
    if (error || stdout.indexOf("no line interfaces") !== -1) {
      logger.error(stdout);
      return false;
    }
    if (!error) {
      Bchannels = _.without(stdout.split("\n"), "");
      data = {};
      _.each(Bchannels, function(bchan) {
        var bchannel, dchannel, di, sp, type;
        sp = bchan.split("/");
        di = sp[0].split(".");
        dchannel = di[0];
        type = di[1];
        if (data[dchannel] === undefined) {
          data[dchannel] = {};
        }
        if (data[dchannel][type] === undefined) {
          data[dchannel][type] = {};
        }
        if (data[dchannel][type]["b"] === undefined) {
          data[dchannel][type]["b"] = {};
        }
        bchannel = sp[1].replace(/B/, "").replace(/b/, "");
        data[dchannel][type]["b"][bchannel] = {};
        data[dchannel][type]["b"][bchannel]["bchannel"] = bchan;
      });
      next(error, data);
    }
  });
};
